NXOpen .NET Reference  12.0.0
Public Types | Public Member Functions | Properties | List of all members
NXOpen.Assemblies.ComponentAssembly Class Reference

Represents the set of NXOpen.Assemblies.Component s that make up an assembly. More...

Inheritance diagram for NXOpen.Assemblies.ComponentAssembly:
NXOpen.NXObject NXOpen.INXObject

Public Types

enum  SubstitutionMode { NonAssociative, SingleComponent, All }
 Defines how a component substitution operation is performed. More...
 
enum  OpenOption { ComponentOnly, ImmediateChildren, WholeAssembly, ReapplyRevRule }
 Open options for open_components More...
 
enum  OpenComponentStatus { SuccessfullyOpened, DeletedByOpen, CouldNotOpen }
 Open Component Status More...
 
enum  CheckinCheckoutOption { DesignElement, SourceItem, Both, Default }
 Check in and Check out options for components More...
 
enum  CloseModified { False, True }
 Indicates how close component should handle component parts when they are modified More...
 
enum  SuppressedState {
  Inherit, Suppressed, Unsuppressed, SuppressedByExp,
  UnsuppressedByExp
}
 Defines the component supression states. More...
 
enum  OrderTargetLocation { PlaceBefore, PlaceAfter }
 Option controls whether reordered NXOpen.Assemblies.Component s are placed before or after the target NXOpen.Assemblies.Component More...
 
- Public Types inherited from NXOpen.NXObject
enum  AttributeType {
  Invalid, Null, Boolean, Integer,
  Real, String, Time, Reference,
  Any = 100
}
 Specifies attribute type. More...
 
enum  DateAndTimeFormat { Numeric, Textual }
 Specifies the format of the date and time attribute. More...
 

Public Member Functions

unsafe NXOpen.Assemblies.Component AddComponent (string partToAdd, string referenceSetName, string componentName, NXOpen.Point3d basePoint, NXOpen.Matrix3x3 orientation, int layer, out NXOpen.PartLoadStatus loadStatus)
 Creates a new NXOpen.Assemblies.Component in this assembly, based on an existing part file. More...
 
unsafe NXOpen.Assemblies.Component AddComponent (string partToAdd, string referenceSetName, string componentName, NXOpen.Point3d basePoint, NXOpen.Matrix3x3 orientation, int layer, out NXOpen.PartLoadStatus loadStatus, bool uomAsNgc)
 Creates a new NXOpen.Assemblies.Component in this assembly, based on an existing part file. More...
 
unsafe void AddComponents (NXOpen.Part[] partsToAdd, NXOpen.Point3d point, NXOpen.Matrix3x3 orientation, int layer, string referenceSetName, int count, bool scatter, out NXOpen.Assemblies.Component[] components)
 Creates new NXOpen.Assemblies.Component in this assembly, based on existing part files. More...
 
unsafe NXOpen.Assemblies.Component AddComponent (NXOpen.BasePart partToAdd, string referenceSetName, string componentName, NXOpen.Point3d basePoint, NXOpen.Matrix3x3 orientation, int layer, out NXOpen.PartLoadStatus loadStatus)
 Creates a new NXOpen.Assemblies.Component in this assembly, based on an existing part file. More...
 
unsafe NXOpen.Assemblies.Component AddMasterPartComponent (string partToAdd, string referenceSetName, string componentName, NXOpen.Point3d basePoint, NXOpen.Matrix3x3 orientation, int layer, out NXOpen.PartLoadStatus loadStatus)
 Creates a new NXOpen.Assemblies.Component in this assembly as master part. More...
 
unsafe NXOpen.Assemblies.Component AddMasterPartComponent (NXOpen.Part partToAdd, string referenceSetName, string componentName, NXOpen.Point3d basePoint, NXOpen.Matrix3x3 orientation, int layer, out NXOpen.PartLoadStatus loadStatus)
 Creates a new NXOpen.Assemblies.Component in this assembly as master part. More...
 
unsafe NXOpen.Assemblies.Component InsertProduct (NXOpen.Part productPart, int layer, out NXOpen.PartLoadStatus loadStatus)
 Adds a product into workset part at identity location. More...
 
unsafe NXOpen.Assemblies.Component SubstituteComponent (NXOpen.Assemblies.Component component, NXOpen.BasePart part, string newName, string referenceSet, int layer, NXOpen.Assemblies.ComponentAssembly.SubstitutionMode mode)
 Substitutes an old component with a new component. More...
 
unsafe void RemoveComponent (NXOpen.Assemblies.Component component)
 Removes a component from this assemebly. More...
 
unsafe NXOpen.Assemblies.Component MapComponentFromParent (NXOpen.Assemblies.Component component)
 Maps a component in a parent assembly onto a corresponding component in this assembly. More...
 
unsafe
NXOpen.Assemblies.Component[] 
MapComponentsFromSubassembly (NXOpen.Assemblies.Component component)
 Maps a component in a subassembly onto the corresponding components in this parent assembly. More...
 
unsafe void ChangeByName (string name, NXOpen.Assemblies.Component[] partOccs)
 Changes the current NXOpen.Assemblies.Arrangement of the given NXOpen.Assemblies.Component s to the NXOpen.Assemblies.Arrangement with the given name. More...
 
unsafe void SetDefault (NXOpen.Assemblies.Arrangement arrangement)
 Set the default NXOpen.Assemblies.Arrangement for the given NXOpen.Assemblies.ComponentAssembly . More...
 
unsafe NXOpen.ErrorList SuppressComponents (NXOpen.Assemblies.Component[] components, NXOpen.Assemblies.Arrangement[] arrangements)
 Suppresses an array of components More...
 
unsafe NXOpen.ErrorList SuppressComponents (NXOpen.Assemblies.Component[] components)
 Suppresses an array of components in all NXOpen.Assemblies.Arrangement s in this ComponentAssembly More...
 
unsafe NXOpen.ErrorList SuppressComponents (NXOpen.Assemblies.Component[] components, NXOpen.Assemblies.Arrangement[] arrangements, string expression)
 Suppresses an array of components in all NXOpen.Assemblies.Arrangement s in this ComponentAssembly More...
 
unsafe NXOpen.ErrorList UnsuppressComponents (NXOpen.Assemblies.Component[] components, NXOpen.Assemblies.Arrangement[] arrangements)
 Unsuppresses an array of components in this ComponentAssembly More...
 
unsafe NXOpen.ErrorList UnsuppressComponents (NXOpen.Assemblies.Component[] components)
 Unsuppresses an array of components in all NXOpen.Assemblies.Arrangement s in this ComponentAssembly More...
 
unsafe NXOpen.ErrorList ReleaseSuppression (NXOpen.Assemblies.Component[] components, NXOpen.Assemblies.Arrangement[] arrangements)
 Release control of the suppression state of an array of components. More...
 
unsafe NXOpen.ErrorList ReleaseSuppression (NXOpen.Assemblies.Component[] components)
 Release control of the suppression state of an array of components. More...
 
unsafe void SetEntirePartRefset (NXOpen.Assemblies.Component component)
 Convenience method for setting the reference set used to represent a component to be the entire part. More...
 
unsafe void SetEmptyRefset (NXOpen.Assemblies.Component component)
 Convenience method for setting the reference set used to represent a component to be empty More...
 
unsafe NXOpen.ErrorList ReplaceReferenceSetInOwners (string newReferenceSet, NXOpen.Assemblies.Component[] components)
 Sets the reference set used to represent each component in an array. More...
 
unsafe void ReplaceReferenceSet (NXOpen.Assemblies.Component component, string newReferenceSet)
 Replaces the reference set used by a component. More...
 
unsafe void MoveComponent (NXOpen.Assemblies.Component component, NXOpen.Vector3d translation, NXOpen.Matrix3x3 rotation)
 Moves a component by specifying a translation and rotation. More...
 
unsafe
NXOpen.Positioning.MatingConverter 
CreateMatingConverter ()
 Creates a NXOpen.Positioning.MatingConverter object for this assembly. More...
 
unsafe void DeleteMatingConditions ()
 Delete all the mating conditions in this assembly. More...
 
unsafe void ConvertRememberedMcs ()
 Converts all remembered mating constraints in the part of this assembly to remembered assembly constraints More...
 
unsafe void SetNonGeometricState (NXOpen.Assemblies.Component component, bool nonGeometricState)
 Sets the component state to Geometric or Non-Geometric. More...
 
unsafe bool GetNonGeometricState (NXOpen.Assemblies.Component component)
 Gets the component state as Geometric or Non-Geometric. More...
 
unsafe
NXOpen.Assemblies.ComponentQuantity 
GetComponentQuantityType (NXOpen.Assemblies.Component component)
 Gets the quantity type of the components. More...
 
unsafe void SetIntegerQuantity (NXOpen.Assemblies.Component component, int integerQuantity)
 Sets the integer quantity on this component. More...
 
unsafe int GetIntegerQuantity (NXOpen.Assemblies.Component component)
 Gets the value of the integer quantity of component. More...
 
unsafe void SetRealQuantity (NXOpen.Assemblies.Component component, double realQuantity, string quantityUnits)
 Sets the real quantity and corresponding units on this component. More...
 
unsafe double GetRealQuantity (NXOpen.Assemblies.Component component, out string units)
 Gets the value of real quantity and corresponding units on this component. More...
 
unsafe void SetAsRequiredQuantity (NXOpen.Assemblies.Component component)
 Sets the as-required quantity on this component. More...
 
unsafe string GetAsRequiredQuantity (NXOpen.Assemblies.Component component)
 Gets the as-required quantity on this component. More...
 
unsafe
NXOpen.Assemblies.Component[] 
CopyComponents (NXOpen.Assemblies.Component[] components)
 Given an array of components, creates copies of the components such that each copy is created under the parent assembly of the original component. More...
 
unsafe void RestructureComponents (NXOpen.Assemblies.Component[] origComponents, NXOpen.Assemblies.Component newParentComponent, bool deleteFlag, out NXOpen.Assemblies.Component[] newComponents, out NXOpen.ErrorList errorList)
 Given an array of components and a specified parent this function will transfer the given components to the parent. More...
 
unsafe NXOpen.PartLoadStatus OpenComponents (NXOpen.Assemblies.ComponentAssembly.OpenOption openOption, NXOpen.Assemblies.Component[] componentsToOpen, out NXOpen.Assemblies.ComponentAssembly.OpenComponentStatus[] openStatus)
 Given an array of components, open the components using the open_option. More...
 
unsafe NXOpen.PartCloseStatus CloseComponents (NXOpen.Assemblies.Component[] componentsToClose, NXOpen.BasePart.CloseWholeTree wholeTree, NXOpen.Assemblies.ComponentAssembly.CloseModified closeModified)
 Given an array of components, close the components. More...
 
unsafe NXOpen.Expression GetSuppressionExpression (NXOpen.Assemblies.Component component)
 Gets the expression controlling the suppression of the component in its controlling arrangement More...
 
unsafe NXOpen.Expression GetSuppressionExpression (NXOpen.Assemblies.Component component, NXOpen.Assemblies.Arrangement arrangement)
 Gets the expression controlling the suppression of the component in the given arrangment More...
 
unsafe
NXOpen.Assemblies.ComponentAssembly.SuppressedState 
GetSuppressedState (NXOpen.Assemblies.Component component, out bool controlled)
 Gets the suppression state of the component in its controlling arrangement More...
 
unsafe
NXOpen.Assemblies.ComponentAssembly.SuppressedState 
GetSuppressedState (NXOpen.Assemblies.Component component, NXOpen.Assemblies.Arrangement arrangement, out bool controlled)
 Gets the suppression state of the component in the given arrangement. More...
 
unsafe
NXOpen.Assemblies.ComponentPatternBuilder 
CreateComponentPatternBuilder (NXOpen.Assemblies.ComponentPattern compPattern)
 Creates a NXOpen.Assemblies.ComponentPatternBuilder object This can be used to create or edit a component pattern. More...
 
unsafe NXOpen.PartLoadStatus AddPendingComponent (string partToAdd, NXOpen.NXObject pendingComponent, string referenceSetName, string componentName, NXOpen.Point3d basePoint, NXOpen.Matrix3x3 orientation, int layer, bool uomAsNgc)
 Add a pending NXOpen.Assemblies.Component in this assembly. More...
 
unsafe
NXOpen.Positioning.ComponentConstraintGroupBuilder 
CreateConstraintGroupBuilder (NXOpen.Positioning.ComponentConstraintGroup group, NXOpen.Assemblies.Component contextComponent)
 Creates a NXOpen.Positioning.ComponentConstraintGroupBuilder object. More...
 
unsafe NXOpen.ErrorList CheckinComponents (NXOpen.Assemblies.Component[] partOccs, NXOpen.Assemblies.ComponentAssembly.CheckinCheckoutOption checkinInputOption)
 Checks in array of components as per the option NXOpen.Assemblies.ComponentAssembly.CheckinCheckoutOption . More...
 
unsafe NXOpen.ErrorList CheckoutComponents (NXOpen.Assemblies.Component[] partOccs, NXOpen.Assemblies.ComponentAssembly.CheckinCheckoutOption checkoutInputOption)
 Checks out array of components as per the option NXOpen.Assemblies.ComponentAssembly.CheckinCheckoutOption . More...
 
unsafe NXOpen.ErrorList CheckoutWorkset ()
 Checks out workset. More...
 
unsafe NXOpen.ErrorList CheckinWorkset ()
 Checks in workset. More...
 
unsafe NXOpen.ErrorList CheckoutAllModifiedObjects (out NXOpen.NXObject[] checkedOutObjects)
 Checks out all modified objects in the current session. More...
 
unsafe void GetCheckedoutStatusOfObjects (out NXOpen.NXObject[] checkedOutObjects, out NXOpen.NXObject[] uncheckedOutObjects)
 Returns the checkedout status (checkedout/non checkedout) of all the objects open in NX. More...
 
unsafe void ReorderComponents (NXOpen.Assemblies.ComponentOrder order, NXOpen.Assemblies.Component[] componentsToReorder, NXOpen.Assemblies.Component targetComponent, NXOpen.Assemblies.ComponentAssembly.OrderTargetLocation beforeOrAfter)
 Reorders the array of NXOpen.Assemblies.Component s before or after the target NXOpen.Assemblies.Component . More...
 
unsafe void ReorderChildrenOfParent (NXOpen.Assemblies.ComponentOrder order, NXOpen.Assemblies.Component parentComponent, NXOpen.Assemblies.Component[] componentsToReorder)
 Assigns a new order to immediate children NXOpen.Assemblies.Component s of parent NXOpen.Assemblies.Component . More...
 
unsafe void GetComponentOrders (out NXOpen.Assemblies.ComponentOrder[] orders)
 Returns all NXOpen.Assemblies.ComponentOrder s available in the part More...
 
unsafe void MoveToPendingComponent (NXOpen.NXObject component)
 Move a NXOpen.Assemblies.Component in this assembly to a pending list. More...
 
unsafe NXOpen.Assemblies.Order GetActiveOrder ()
 Returns the active order in the part More...
 
unsafe NXOpen.ErrorList CreateIsolateViewWithComponents (NXOpen.Assemblies.Component[] components, out NXOpen.View view)
 Creates a temporary NXOpen.View and shows array of components in it and treats this as Isolate view till it gets undisplayed. More...
 
unsafe NXOpen.ErrorList ShowComponentsInIsolateView (NXOpen.Assemblies.Component[] components, out NXOpen.View view)
 Shows array of components in Isolate view NXOpen.View . More...
 
unsafe NXOpen.ErrorList HideComponentsInIsolateView (NXOpen.Assemblies.Component[] components, out NXOpen.View view)
 Hides array of components in Isolate view NXOpen.View . More...
 
- Public Member Functions inherited from NXOpen.NXObject
unsafe void SetUserAttribute (NXOpen.NXObject.AttributeInformation info, NXOpen.Update.Option option)
 Creates or modifies an attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, int value, NXOpen.Update.Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, double value, NXOpen.Update.Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
unsafe void SetUserAttribute (string title, int index, NXOpen.Update.Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
unsafe void SetTimeUserAttribute (string title, int index, string value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe void SetTimeUserAttribute (string title, int index, NXOpen.NXObject.ComputationalTime value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe void SetBooleanUserAttribute (string title, int index, bool value, NXOpen.Update.Option option)
 Creates or modifies a boolean attribute with the option to update or not. More...
 
unsafe NXOpen.AttributeIterator CreateAttributeIterator ()
 Create an attribute iterator More...
 
unsafe bool HasUserAttribute (NXOpen.AttributeIterator iterator)
 Determines if an attribute exists on the object, that satisfies the given iterator More...
 
unsafe bool HasUserAttribute (string title, NXOpen.NXObject.AttributeType type, int index)
 Determines if an attribute with the given Title, Type and array Index is present on the object Unset attributes will not be detected by this function, as its purpose is to test for the actual presence of the attribute on the object. More...
 
unsafe int GetUserAttributeCount (NXOpen.AttributeIterator iterator)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
unsafe int GetUserAttributeCount (NXOpen.AttributeIterator iterator, bool countArrayAsOneAttribute)
 Gets the count of set attributes on the object, if any, that satisfy the given iterator. More...
 
unsafe int GetUserAttributeCount (NXOpen.NXObject.AttributeType type)
 Gets the count of set attributes on the object, if any, of the given type. More...
 
unsafe int GetUserAttributeCount (NXOpen.NXObject.AttributeType type, bool includeUnset, bool countArrayAsOneAttribute)
 Gets the count of attributes on the object, if any, of the given type. More...
 
unsafe int GetUserAttributeSize (string title, NXOpen.NXObject.AttributeType type)
 Gets the size of the first attribute encountered on the object, if any, with a given Title and Type. More...
 
unsafe bool GetNextUserAttribute (NXOpen.AttributeIterator iterator, out NXOpen.NXObject.AttributeInformation info)
 Gets the next attribute encountered on the object, if any, that satisfies the given iterator. More...
 
unsafe
NXOpen.NXObject.AttributeInformation 
GetUserAttribute (string title, NXOpen.NXObject.AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given Title, Type and array Index. More...
 
unsafe bool GetBooleanUserAttribute (string title, int index)
 Gets a boolean attribute by Title and array Index. More...
 
unsafe int GetIntegerUserAttribute (string title, int index)
 Gets an integer attribute by Title and array Index. More...
 
unsafe double GetRealUserAttribute (string title, int index)
 Gets a real attribute by Title and array Index. More...
 
unsafe string GetStringUserAttribute (string title, int index)
 Gets a string attribute by Title and array Index. More...
 
unsafe string GetTimeUserAttribute (string title, int index)
 Gets a time attribute by Title and array Index. More...
 
unsafe
NXOpen.NXObject.ComputationalTime 
GetComputationalTimeUserAttribute (string title, int index)
 Gets a time attribute by Title and array Index. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (NXOpen.AttributeIterator iterator)
 Gets all the attributes that have been set on the given object, if any, that satisfy the given iterator. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes ()
 Gets all the attributes that have been set on the given object. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (bool includeUnset)
 Gets all the attributes of the given object. More...
 
unsafe string GetUserAttributeAsString (string title, NXOpen.NXObject.AttributeType type, int index)
 Gets the first attribute encountered on the object, if any, with a given title, type and array index. More...
 
unsafe void DeleteUserAttributes (NXOpen.AttributeIterator iterator, NXOpen.Update.Option option)
 Deletes the attributes on the object, if any, that satisfy the given iterator More...
 
unsafe void DeleteUserAttribute (NXOpen.NXObject.AttributeType type, string title, bool deleteEntireArray, NXOpen.Update.Option option)
 Deletes the first attribute encountered with the given Type, Title. More...
 
unsafe void DeleteUserAttributes (NXOpen.NXObject.AttributeType type, NXOpen.Update.Option option)
 Deletes the attributes encountered with the given Type with option to update or not. More...
 
unsafe void SetUserAttributeLock (string title, NXOpen.NXObject.AttributeType type, bool @lock)
 Lock or unlock the given attribute. More...
 
unsafe bool GetUserAttributeLock (string title, NXOpen.NXObject.AttributeType type)
 Determine the lock of the given attribute. More...
 
unsafe NXOpen.NXObject[] GetUserAttributeSourceObjects ()
 Returns an array of objects from which this object presents attributes. More...
 
unsafe void SetPdmReferenceAttribute (string attributeTitle, string attributeValue)
 Sets the value of PDM Reference attribute on the object. More...
 
unsafe string GetPdmReferenceAttributeValue (string attributeTitle)
 Gets the value of PDM Reference attribute for given object. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttribute (string title, bool includeUnset, bool addStringValues, NXOpen.NXObject.AttributeType type)
 Gets the first attribute (or attribute array) encountered on the object, if any, with a given Title and Type. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetUserAttributes (bool includeUnset, bool addStringValues)
 Gets all the attributes of the given object. More...
 
unsafe void DeleteAllAttributesByType (NXOpen.NXObject.AttributeType type)
 Deletes all attributes of a specific type. More...
 
unsafe void DeleteAllAttributesByType (NXOpen.NXObject.AttributeType type, NXOpen.Update.Option option)
 Deletes all attributes of a specific type with the option to update or not. More...
 
unsafe void SetAttribute (string title, int value)
 Creates or modifies an integer attribute. More...
 
unsafe void SetAttribute (string title, int value, NXOpen.Update.Option option)
 Creates or modifies an integer attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title, double value)
 Creates or modifies a real attribute. More...
 
unsafe void SetAttribute (string title, double value, NXOpen.Update.Option option)
 Creates or modifies a real attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title, string value)
 Creates or modifies a string attribute. More...
 
unsafe void SetAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute with the option to update or not. More...
 
unsafe void SetAttribute (string title)
 Creates or modifies a null attribute which is an attribute with a title and no value. More...
 
unsafe void SetAttribute (string title, NXOpen.Update.Option option)
 Creates or modifies a null attribute with the option to update or not. More...
 
unsafe void SetTimeAttribute (string title, string value)
 Creates or modifies a time attribute. More...
 
unsafe void SetTimeAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a time attribute with the option to update or not. More...
 
unsafe int GetIntegerAttribute (string title)
 Gets an integer attribute by title. More...
 
unsafe double GetRealAttribute (string title)
 Gets a real attribute by title. More...
 
unsafe string GetStringAttribute (string title)
 Gets a string attribute value by title. More...
 
unsafe string GetTimeAttribute (NXOpen.NXObject.DateAndTimeFormat format, string title)
 Gets a time attribute by title. More...
 
unsafe string GetReferenceAttribute (string title)
 Gets the reference string (not the calculated value) of a string attribute that uses a reference string. More...
 
unsafe void DeleteAttributeByTypeAndTitle (NXOpen.NXObject.AttributeType type, string title)
 Deletes an attribute by type and title. More...
 
unsafe void DeleteAttributeByTypeAndTitle (NXOpen.NXObject.AttributeType type, string title, NXOpen.Update.Option option)
 Deletes an attribute by type and title with the option to update or not. More...
 
unsafe void SetReferenceAttribute (string title, string value)
 Creates or modifies a string attribute which uses a reference string. More...
 
unsafe void SetReferenceAttribute (string title, string value, NXOpen.Update.Option option)
 Creates or modifies a string attribute which uses a reference string, with the option to update or not. More...
 
unsafe
NXOpen.NXObject.AttributeInformation[] 
GetAttributeTitlesByType (NXOpen.NXObject.AttributeType type)
 Gets all the attribute titles of a specific type. More...
 
unsafe string[] GetUserAttributesAsStrings ()
 Gets all the attributes that have been set on the given object. More...
 
unsafe NXOpen.INXObject FindObject (string journalIdentifier)
 Finds the NXOpen.NXObject with the given identifier as recorded in a journal. More...
 
unsafe void Print ()
 Prints a representation of this object to the system log file. More...
 
unsafe void SetName (string name)
 Sets the custom name of the object. More...
 

Properties

NXOpen.Assemblies.ArrangementCollection Arrangements [get]
 The collection of NXOpen.Assemblies.Arrangement s defined in the ComponentAssembly More...
 
NXOpen.Assemblies.ExplosionCollection Explosions [get]
 The collection of NXOpen.Assemblies.Explosion s defined in the ComponentAssembly More...
 
NXOpen.Assemblies.DrawingExplosionCollection DrawingExplosions [get]
 The collection of NXOpen.Assemblies.DrawingExplosion s defined in the ComponentAssembly More...
 
NXOpen.Assemblies.ComponentPatternCollection ComponentPatterns [get]
 The collection of NXOpen.Assemblies.ComponentPattern defined in the ComponentAssembly More...
 
NXOpen.Assemblies.SubsetCollection Subsets [get]
 The collection of NXOpen.Assemblies.Subset s defined in the ComponentAssembly More...
 
NXOpen.Assemblies.ClearanceSetCollection ClearanceSets [get]
 The collection of NXOpen.Assemblies.ClearanceSet s defined in the ComponentAssembly More...
 
NXOpen.Assemblies.OrderCollection OrdersSet [get]
 The collection of NXOpen.Assemblies.Order s defined in the ComponentAssembly More...
 
unsafe
NXOpen.Assemblies.Arrangement 
ActiveArrangement [get, set]
 Returns or sets the currently active NXOpen.Assemblies.Arrangement for this ComponentAssembly More...
 
unsafe
NXOpen.Positioning.ComponentPositioner 
Positioner [get]
 Returns the component positioner for this assembly. More...
 
unsafe NXOpen.Assemblies.Component RootComponent [get]
 Returns the top-level component, i.e. More...
 
- Properties inherited from NXOpen.NXObject
unsafe bool IsOccurrence [get]
 Returns whether this object is an occurrence or not. More...
 
unsafe string JournalIdentifier [get]
 Returns the identifier that would be recorded in a journal for this object. More...
 
unsafe string Name [get]
 Returns the custom name of the object. More...
 
unsafe NXOpen.Assemblies.Component OwningComponent [get]
 Returns the owning component, if this object is an occurrence. More...
 
unsafe NXOpen.BasePart OwningPart [get]
 Returns the owning part of this object More...
 
unsafe NXOpen.INXObject Prototype [get]
 Returns the prototype of this object if it is an occurrence. More...
 
- Properties inherited from NXOpen.INXObject
bool IsOccurrence [get]
 Returns whether this object is an occurrence or not. More...
 
string JournalIdentifier [get]
 Returns the identifier that would be recorded in a journal for this object. More...
 
string Name [get]
 Returns the custom name of the object. More...
 
NXOpen.Assemblies.Component OwningComponent [get]
 Returns the owning component, if this object is an occurrence. More...
 
NXOpen.BasePart OwningPart [get]
 Returns the owning part of this object More...
 
NXOpen.INXObject Prototype [get]
 Returns the prototype of this object if it is an occurrence. More...
 

Detailed Description

Represents the set of NXOpen.Assemblies.Component s that make up an assembly.

Components are arranged in a tree structure, with a single component at the root. (See NXOpen.Assemblies.ComponentAssembly.RootComponent .) The components directly below the root are added to this assembly by calling NXOpen.Assemblies.ComponentAssembly.AddComponent . These "Top Level" components are said to be owned directly by this assembly. Top Level components may themselves have subcomponents.

Certain methods in this class will only operate on Top Level components. For example, NXOpen.Assemblies.ComponentAssembly.MoveComponent will throw an exception if the input component is not owned directly by this assembly.

Note, however, that input components will be mapped onto the correct component in the assembly. See NXOpen.Assemblies.ComponentAssembly.MapComponentFromParent .

For any methods that specify a component's position, the orientation matrix is in column order. The first column of the matrix specifies the X axis, the second the Y axis, and the third the Z axis.

To obtain an instance of this class, use NXOpen.BasePart.ComponentAssembly

Created in NX3.0.0

Member Enumeration Documentation

Check in and Check out options for components

Enumerator
DesignElement 

Checks in or Checks out the design element

SourceItem 

Checks in or Checks out the source item that is referenced by a reuse design element or subordinate design element

Both 

Checks in or Checks out the design element and its referenced source item

Default 

Check In or Check Out option is determined by the system using whatever option is appropriate for the selected object type.

For Reuse design element, the system defaults to checking out both the design element and the underlying item.

Indicates how close component should handle component parts when they are modified

Enumerator
False 

Close only unmodified parts, not modified parts

True 

Close all parts, modified and unmodified

Open Component Status

Enumerator
SuccessfullyOpened 

The component was opened as expected

DeletedByOpen 

The component was deleted on load as a result of the open

CouldNotOpen 

The component could not be opened

Open options for open_components

Enumerator
ComponentOnly 

Open the component but none of its children

ImmediateChildren 

Open the immediate children of an already open component

WholeAssembly 

Open the component and all of its children

ReapplyRevRule 

Reconfigure and open components based on current revision rules.

If this option is used in native mode, it will behave just like Open Component.

Option controls whether reordered NXOpen.Assemblies.Component s are placed before or after the target NXOpen.Assemblies.Component

Enumerator
PlaceBefore 

Move reordered NXOpen.Assemblies.Component s before the target NXOpen.Assemblies.Component

PlaceAfter 

Move reordered NXOpen.Assemblies.Component s after the target NXOpen.Assemblies.Component

Defines how a component substitution operation is performed.

Enumerator
NonAssociative 

The old component is deleted, and the new one is added

SingleComponent 

An associative substitution is performed.

As far as possible, this will attempt to preserve assembly constraints and interpart links.

All 

An associative substitution is performed on all components that represent the same prototype part.

This effectively substitutes one child part for a new one.

Defines the component supression states.

Enumerator
Inherit 

Inherit

Suppressed 

Suppressed

Unsuppressed 

Unsuppressed

SuppressedByExp 

Suppressed by expression

UnsuppressedByExp 

Unsuppressed by expression

Member Function Documentation

unsafe NXOpen.Assemblies.Component NXOpen.Assemblies.ComponentAssembly.AddComponent ( string  partToAdd,
string  referenceSetName,
string  componentName,
NXOpen.Point3d  basePoint,
NXOpen.Matrix3x3  orientation,
int  layer,
out NXOpen.PartLoadStatus  loadStatus 
)

Creates a new NXOpen.Assemblies.Component in this assembly, based on an existing part file.

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
partToAddThe part that defines the new component
referenceSetNameThe name of the reference set used to represent the new component
componentNameThe name of the new component
basePointLocation of the new component
orientationOrientation matrix for the new component, in column order.
layerThe layer to place the new component on -1 means use the original layers defined in the component. 0 means use the work layer. 1-256 means use the specified layer.
loadStatusResult of loading the part_to_add
Returns
The new Component
unsafe NXOpen.Assemblies.Component NXOpen.Assemblies.ComponentAssembly.AddComponent ( string  partToAdd,
string  referenceSetName,
string  componentName,
NXOpen.Point3d  basePoint,
NXOpen.Matrix3x3  orientation,
int  layer,
out NXOpen.PartLoadStatus  loadStatus,
bool  uomAsNgc 
)

Creates a new NXOpen.Assemblies.Component in this assembly, based on an existing part file.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
partToAddThe part that defines the new component
referenceSetNameThe name of the reference set used to represent the new component
componentNameThe name of the new component
basePointLocation of the new component
orientationOrientation matrix for the new component, in column order.
layerThe layer to place the new component on -1 means use the original layers defined in the component. 0 means use the work layer. 1-256 means use the specified layer.
loadStatusResult of loading the part_to_add
Returns
The new Component
Parameters
uomAsNgcWhether to set to non-geometric if with unit-of-measure
unsafe NXOpen.Assemblies.Component NXOpen.Assemblies.ComponentAssembly.AddComponent ( NXOpen.BasePart  partToAdd,
string  referenceSetName,
string  componentName,
NXOpen.Point3d  basePoint,
NXOpen.Matrix3x3  orientation,
int  layer,
out NXOpen.PartLoadStatus  loadStatus 
)

Creates a new NXOpen.Assemblies.Component in this assembly, based on an existing part file.

Created in NX4.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
partToAddThe part that defines the new component
referenceSetNameThe name of the reference set used to represent the new component
componentNameThe name of the new component
basePointLocation of the new component
orientationOrientation matrix for the new component, in column order.
layerThe layer to place the new component on -1 means use the original layers defined in the component. 0 means use the work layer. 1-256 means use the specified layer.
loadStatusResult of loading the part_to_add
Returns
The new Component
unsafe void NXOpen.Assemblies.ComponentAssembly.AddComponents ( NXOpen.Part[]  partsToAdd,
NXOpen.Point3d  point,
NXOpen.Matrix3x3  orientation,
int  layer,
string  referenceSetName,
int  count,
bool  scatter,
out NXOpen.Assemblies.Component[]  components 
)

Creates new NXOpen.Assemblies.Component in this assembly, based on existing part files.

Created in NX12.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
partsToAddThe parts that define new components
pointLocation of the new component
orientationOrientation matrix for the new component, in column order.
layerThe layer to place the new component on -1 means use the original layers defined in the component. 0 means use the work layer. 1-256 means use the specified layer.
referenceSetNameThe name of the reference set used to represent the new component
countnumber of times each part to be added as component in parent part
scatterScatter the multiple components around the specified location
componentsThe array of components added to the parent part
unsafe NXOpen.Assemblies.Component NXOpen.Assemblies.ComponentAssembly.AddMasterPartComponent ( string  partToAdd,
string  referenceSetName,
string  componentName,
NXOpen.Point3d  basePoint,
NXOpen.Matrix3x3  orientation,
int  layer,
out NXOpen.PartLoadStatus  loadStatus 
)

Creates a new NXOpen.Assemblies.Component in this assembly as master part.

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
partToAddThe part that defines the new component
referenceSetNameThe name of the reference set used to represent the new component
componentNameThe name of the new component
basePointLocation of the new component
orientationOrientation matrix for the new component, in column order.
layerThe layer to place the new component on -1 means use the original layers defined in the component. 0 means use the work layer. 1-256 means use the specified layer.
loadStatusResult of loading the part_to_add
Returns
The new Component
unsafe NXOpen.Assemblies.Component NXOpen.Assemblies.ComponentAssembly.AddMasterPartComponent ( NXOpen.Part  partToAdd,
string  referenceSetName,
string  componentName,
NXOpen.Point3d  basePoint,
NXOpen.Matrix3x3  orientation,
int  layer,
out NXOpen.PartLoadStatus  loadStatus 
)

Creates a new NXOpen.Assemblies.Component in this assembly as master part.

Created in NX4.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
partToAddThe part that defines the new component
referenceSetNameThe name of the reference set used to represent the new component
componentNameThe name of the new component
basePointLocation of the new component
orientationOrientation matrix for the new component, in column order.
layerThe layer to place the new component on -1 means use the original layers defined in the component. 0 means use the work layer. 1-256 means use the specified layer.
loadStatusResult of loading the part_to_add
Returns
The new Component
unsafe NXOpen.PartLoadStatus NXOpen.Assemblies.ComponentAssembly.AddPendingComponent ( string  partToAdd,
NXOpen.NXObject  pendingComponent,
string  referenceSetName,
string  componentName,
NXOpen.Point3d  basePoint,
NXOpen.Matrix3x3  orientation,
int  layer,
bool  uomAsNgc 
)

Add a pending NXOpen.Assemblies.Component in this assembly.

Created in NX8.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
partToAddThe part that defines the new component
pendingComponentcomponent to add
referenceSetNameThe name of the reference set used to represent the new component
componentNameThe name of the new component
basePointLocation of the new component
orientationOrientation matrix for the new component, in column order.
layerThe layer to place the new component on -1 means use the original layers defined in the component. 0 means use the work layer. 1-256 means use the specified layer.
uomAsNgcWhether to set to non-geometric if with unit-of-measure
Returns
Result of loading the part_to_add
unsafe void NXOpen.Assemblies.ComponentAssembly.ChangeByName ( string  name,
NXOpen.Assemblies.Component[]  partOccs 
)

Changes the current NXOpen.Assemblies.Arrangement of the given NXOpen.Assemblies.Component s to the NXOpen.Assemblies.Arrangement with the given name.

Created in NX7.5.2

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
nameThe name of arrangement to change to
partOccsThe NXOpen.Assemblies.Component s to be modified
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.CheckinComponents ( NXOpen.Assemblies.Component[]  partOccs,
NXOpen.Assemblies.ComponentAssembly.CheckinCheckoutOption  checkinInputOption 
)

Checks in array of components as per the option NXOpen.Assemblies.ComponentAssembly.CheckinCheckoutOption .

Created in NX8.5.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
partOccsArray of components to check in
checkinInputOptionOption that controls what to check in
Returns
Any errors that occurred during the check in
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.CheckinWorkset ( )

Checks in workset.

Created in NX8.5.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Returns
Any errors that occurred during checking in of workset
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.CheckoutAllModifiedObjects ( out NXOpen.NXObject[]  checkedOutObjects)

Checks out all modified objects in the current session.

checkedOutObjects collection will be type of NXOpen.BasePart or NXOpen.PDM.DesignElementRevision

Created in NX8.5.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
checkedOutObjectsArray of NXObjects checked out
Returns
Any errors that occurred during checking out of objects
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.CheckoutComponents ( NXOpen.Assemblies.Component[]  partOccs,
NXOpen.Assemblies.ComponentAssembly.CheckinCheckoutOption  checkoutInputOption 
)

Checks out array of components as per the option NXOpen.Assemblies.ComponentAssembly.CheckinCheckoutOption .

Created in NX8.5.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
partOccsArray of components to check out
checkoutInputOptionOption that controls what to check out
Returns
Any errors that occurred during the check out
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.CheckoutWorkset ( )

Checks out workset.

Created in NX8.5.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Returns
Any errors that occurred during checking out of workset
unsafe NXOpen.PartCloseStatus NXOpen.Assemblies.ComponentAssembly.CloseComponents ( NXOpen.Assemblies.Component[]  componentsToClose,
NXOpen.BasePart.CloseWholeTree  wholeTree,
NXOpen.Assemblies.ComponentAssembly.CloseModified  closeModified 
)

Given an array of components, close the components.

This close of the components will check for different reasons that the part cannot be closed. The reasons will be returned in the PartCloseStatus object.

Created in NX6.0.1

License requirements: None.

Parameters
componentsToCloseArray of components to close
wholeTreeIf true, unloads all components of the part. If false, unloads only the top-level part
closeModifiedBehavior of close if component parts are modified.
Returns
Close status for the parts
unsafe void NXOpen.Assemblies.ComponentAssembly.ConvertRememberedMcs ( )

Converts all remembered mating constraints in the part of this assembly to remembered assembly constraints

Created in NX7.5.0

License requirements: assemblies ("ASSEMBLIES MODULE")

unsafe NXOpen.Assemblies.Component [] NXOpen.Assemblies.ComponentAssembly.CopyComponents ( NXOpen.Assemblies.Component[]  components)

Given an array of components, creates copies of the components such that each copy is created under the parent assembly of the original component.

The original components do not need to be under the same parent assembly as each other.

The number of new components may be different from the original number of components if problems occurred during the copy.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentsComponents to be copied.
Returns
The newly created copies.
unsafe NXOpen.Assemblies.ComponentPatternBuilder NXOpen.Assemblies.ComponentAssembly.CreateComponentPatternBuilder ( NXOpen.Assemblies.ComponentPattern  compPattern)

Creates a NXOpen.Assemblies.ComponentPatternBuilder object This can be used to create or edit a component pattern.

Created in NX9.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
compPatternThe pattern definition object will be used in edit
Returns
unsafe NXOpen.Positioning.ComponentConstraintGroupBuilder NXOpen.Assemblies.ComponentAssembly.CreateConstraintGroupBuilder ( NXOpen.Positioning.ComponentConstraintGroup  group,
NXOpen.Assemblies.Component  contextComponent 
)

Creates a NXOpen.Positioning.ComponentConstraintGroupBuilder object.

This can be used to create a constraint group or edit an existing constraint group. The context component decides which displayed constraints are to be used from the member constraints of an existing constraint group. If the context component is a null reference (Nothing in Visual Basic) the displayed constraints used are in the same part as the member constraints.

Created in NX8.0.1

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
groupGroup to be edited, if a null reference (Nothing in Visual Basic) then a new group is created
contextComponentContext component, can be a null reference (Nothing in Visual Basic)
Returns
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.CreateIsolateViewWithComponents ( NXOpen.Assemblies.Component[]  components,
out NXOpen.View  view 
)

Creates a temporary NXOpen.View and shows array of components in it and treats this as Isolate view till it gets undisplayed.

Only one Isolate view can be created for the assembly. Returns NXOpen.View which is treated as Isolate View.

Created in NX11.0.1

License requirements: gateway ("UG GATEWAY")

Parameters
componentsArray of components to be shown in isolate view
viewReturn the isolate view
Returns
list of errors encountered during components shown in isolate view
unsafe NXOpen.Positioning.MatingConverter NXOpen.Assemblies.ComponentAssembly.CreateMatingConverter ( )

Creates a NXOpen.Positioning.MatingConverter object for this assembly.

This can be used to convert Mating Conditions in this part and in its child components to Assembly Constraints. Note that this part need not be the work part for this.

Created in NX5.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Returns
The new Mating Converter
unsafe void NXOpen.Assemblies.ComponentAssembly.DeleteMatingConditions ( )

Delete all the mating conditions in this assembly.

This can be used before creating assembly constraints in the assembly, if the mating conditions are not being converted. Component-component mating conditions and inherited mating conditions are not deleted. Update should be called afterwards.

Created in NX7.5.0

License requirements: assemblies ("ASSEMBLIES MODULE")

unsafe NXOpen.Assemblies.Order NXOpen.Assemblies.ComponentAssembly.GetActiveOrder ( )

Returns the active order in the part

Created in NX10.0.3

License requirements: assemblies ("ASSEMBLIES MODULE")

Returns
unsafe string NXOpen.Assemblies.ComponentAssembly.GetAsRequiredQuantity ( NXOpen.Assemblies.Component  component)

Gets the as-required quantity on this component.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to edit. Must be directly owned by this assembly.
Returns
As-Required string "A/R"
unsafe void NXOpen.Assemblies.ComponentAssembly.GetCheckedoutStatusOfObjects ( out NXOpen.NXObject[]  checkedOutObjects,
out NXOpen.NXObject[]  uncheckedOutObjects 
)

Returns the checkedout status (checkedout/non checkedout) of all the objects open in NX.

Created in NX8.5.0

License requirements: None.

Parameters
checkedOutObjectsArray of NXObjects which are open in session and checked out
uncheckedOutObjectsArray of NXObjects which are open in session but not checkout
unsafe void NXOpen.Assemblies.ComponentAssembly.GetComponentOrders ( out NXOpen.Assemblies.ComponentOrder[]  orders)

Returns all NXOpen.Assemblies.ComponentOrder s available in the part

Created in NX9.0.0

License requirements: None.

Parameters
ordersReturns array of NXOpen.Assemblies.ComponentOrder s in part
unsafe NXOpen.Assemblies.ComponentQuantity NXOpen.Assemblies.ComponentAssembly.GetComponentQuantityType ( NXOpen.Assemblies.Component  component)

Gets the quantity type of the components.

Returns NXOpen.Assemblies.ComponentQuantity .

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to query. Must be directly owned by this assembly.
Returns
Quantity type an enumeration value
unsafe int NXOpen.Assemblies.ComponentAssembly.GetIntegerQuantity ( NXOpen.Assemblies.Component  component)

Gets the value of the integer quantity of component.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to query. Must be directly owned by this assembly.
Returns
Integer quantity value
unsafe bool NXOpen.Assemblies.ComponentAssembly.GetNonGeometricState ( NXOpen.Assemblies.Component  component)

Gets the component state as Geometric or Non-Geometric.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to query. Must be directly owned by this assembly.
Returns
True if the component is non-geometric, false otherwise
unsafe double NXOpen.Assemblies.ComponentAssembly.GetRealQuantity ( NXOpen.Assemblies.Component  component,
out string  units 
)

Gets the value of real quantity and corresponding units on this component.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to query. Must be directly owned by this assembly.
Returns
Real quantity value
Parameters
unitsUnits
unsafe NXOpen.Assemblies.ComponentAssembly.SuppressedState NXOpen.Assemblies.ComponentAssembly.GetSuppressedState ( NXOpen.Assemblies.Component  component,
out bool  controlled 
)

Gets the suppression state of the component in its controlling arrangement

Created in NX6.0.4

License requirements: None.

Parameters
componentThe component to query.
Returns
The suppressed state
Parameters
controlledIs the suppression state controlled at the level of arrangement?
unsafe NXOpen.Assemblies.ComponentAssembly.SuppressedState NXOpen.Assemblies.ComponentAssembly.GetSuppressedState ( NXOpen.Assemblies.Component  component,
NXOpen.Assemblies.Arrangement  arrangement,
out bool  controlled 
)

Gets the suppression state of the component in the given arrangement.

Created in NX6.0.4

License requirements: None.

Parameters
componentThe component to query.
arrangementArrangements in which components should be suppressed.
Returns
The suppressed state
Parameters
controlledIs the suppression state controlled at the level of arrangement?
unsafe NXOpen.Expression NXOpen.Assemblies.ComponentAssembly.GetSuppressionExpression ( NXOpen.Assemblies.Component  component)

Gets the expression controlling the suppression of the component in its controlling arrangement

Created in NX6.0.4

License requirements: None.

Parameters
componentThe component to query.
Returns
The suppression expression.
unsafe NXOpen.Expression NXOpen.Assemblies.ComponentAssembly.GetSuppressionExpression ( NXOpen.Assemblies.Component  component,
NXOpen.Assemblies.Arrangement  arrangement 
)

Gets the expression controlling the suppression of the component in the given arrangment

Created in NX6.0.4

License requirements: None.

Parameters
componentThe component to query.
arrangementThe arrangement in which to query the suppressed state
Returns
The suppression expression.
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.HideComponentsInIsolateView ( NXOpen.Assemblies.Component[]  components,
out NXOpen.View  view 
)

Hides array of components in Isolate view NXOpen.View .

If Isolate view doesn't exist then this API doesn't do anything. Returns NXOpen.View which is treated as Isolate View.

Created in NX11.0.1

License requirements: gateway ("UG GATEWAY")

Parameters
componentsArray of components to be shown in isolate view
viewReturn the isolate view
Returns
list of errors encountered during components shown in isolate view
unsafe NXOpen.Assemblies.Component NXOpen.Assemblies.ComponentAssembly.InsertProduct ( NXOpen.Part  productPart,
int  layer,
out NXOpen.PartLoadStatus  loadStatus 
)

Adds a product into workset part at identity location.

Created in NX12.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
productPartThe product being added to the workset
layerThe layer to place the new component on -1 means use the original layers defined in the component. 0 means use the work layer. 1-256 means use the specified layer.
loadStatusResult of loading the part_to_add
Returns
The new Component
unsafe NXOpen.Assemblies.Component NXOpen.Assemblies.ComponentAssembly.MapComponentFromParent ( NXOpen.Assemblies.Component  component)

Maps a component in a parent assembly onto a corresponding component in this assembly.

For example, given an Axle assembly:

Axle
/ \
/ \
Left Right
Wheel Wheel

and a Car assembly containing two Axle components:

Car
_______ |_______
/ \
/ \
Front Rear
Axle Axle
/ \ / \
/ \ / \
Front Left Front Right Rear Left Rear Right
Wheel Wheel Wheel Wheel

then calling Axle.MapComponentFromParent with the Front Left Wheel component will return the Left Wheel component. Note that calling Car.MapComponentFromParent on Left Wheel will not work. See NXOpen.Assemblies.ComponentAssembly.MapComponentsFromSubassembly .

Calling Axle.MapComponent with the Left Wheel component will simply return Left Wheel, i.e. it is a null operation.

Note that calling this method may load additional assembly data from the Axle part.

Created in NX3.0.0

License requirements: None.

Parameters
componentThe component to map. This should be defined in the tree of a parent assembly which contains this assembly.
Returns
The mapped component. This will be defined in the component tree of this assembly parameter.
unsafe NXOpen.Assemblies.Component [] NXOpen.Assemblies.ComponentAssembly.MapComponentsFromSubassembly ( NXOpen.Assemblies.Component  component)

Maps a component in a subassembly onto the corresponding components in this parent assembly.

For example, given an Axle assembly:

Axle
/ \
/ \
Left Right
Wheel Wheel

and a Car assembly containing two Axle components:

Car
_______ |_______
/ \
/ \
Front Rear
Axle Axle
/ \ / \
/ \ / \
Front Left Front Right Rear Left Rear Right
Wheel Wheel Wheel Wheel

then calling Car.MapComponentsFromSubassembly on Left Wheel will return Front Left Wheel and Rear Left Wheel. See also NXOpen.Assemblies.ComponentAssembly.MapComponentFromParent .

Created in NX3.0.0

License requirements: None.

Parameters
componentThe component to map. This must be defined in a subassembly of this assembly.
Returns
The mapped components.
unsafe void NXOpen.Assemblies.ComponentAssembly.MoveComponent ( NXOpen.Assemblies.Component  component,
NXOpen.Vector3d  translation,
NXOpen.Matrix3x3  rotation 
)

Moves a component by specifying a translation and rotation.

Note that these are specified in the coordinates of this assembly, which are not necessarily the coordinates of the displayed part. Note that the rotation matrix is expected to be stored in a column order fashion.

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to edit. Must be directly owned by this assembly
translationThe translation delta
rotationThe rotation delta, in column order.
unsafe void NXOpen.Assemblies.ComponentAssembly.MoveToPendingComponent ( NXOpen.NXObject  component)

Move a NXOpen.Assemblies.Component in this assembly to a pending list.

The NXOpen.Assemblies.Component should be previously in the pending list and just got added into the assembly.

Created in NX10.0.2

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentcomponent to move to pending list
unsafe NXOpen.PartLoadStatus NXOpen.Assemblies.ComponentAssembly.OpenComponents ( NXOpen.Assemblies.ComponentAssembly.OpenOption  openOption,
NXOpen.Assemblies.Component[]  componentsToOpen,
out NXOpen.Assemblies.ComponentAssembly.OpenComponentStatus[]  openStatus 
)

Given an array of components, open the components using the open_option.

Created in NX6.0.1

License requirements: None.

Parameters
openOptionThe option that controls the open operation
componentsToOpenArray of components to open
openStatusShows the status of the objects in an indexed array according to if they could be opened
Returns
If any components could not be loaded, this object contains the error information.
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.ReleaseSuppression ( NXOpen.Assemblies.Component[]  components,
NXOpen.Assemblies.Arrangement[]  arrangements 
)

Release control of the suppression state of an array of components.

The components will no longer have their suppression state controlled by the given arrangements. (Note that it is not an error if the given arrangements do not control the components.)

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentsNXOpen.Assemblies.Component s to be released
arrangementsArrangements in which components should be released. These arrangements must be defined in this ComponentAssembly
Returns
list of errors encountered during the release
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.ReleaseSuppression ( NXOpen.Assemblies.Component[]  components)

Release control of the suppression state of an array of components.

The components will no longer have their suppression state controlled by any of the arrangements in the ComponentAssembly.

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentsNXOpen.Assemblies.Component s to be released
Returns
list of errors encountered during the release
unsafe void NXOpen.Assemblies.ComponentAssembly.RemoveComponent ( NXOpen.Assemblies.Component  component)

Removes a component from this assemebly.

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to remove. Must be directly owned by this assembly.
unsafe void NXOpen.Assemblies.ComponentAssembly.ReorderChildrenOfParent ( NXOpen.Assemblies.ComponentOrder  order,
NXOpen.Assemblies.Component  parentComponent,
NXOpen.Assemblies.Component[]  componentsToReorder 
)

Assigns a new order to immediate children NXOpen.Assemblies.Component s of parent NXOpen.Assemblies.Component .

Created in NX9.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
orderNXOpen.Assemblies.ComponentOrder in which children are reordered
parentComponentParent component whose children are reordered
componentsToReorderArray of children components in new order
unsafe void NXOpen.Assemblies.ComponentAssembly.ReorderComponents ( NXOpen.Assemblies.ComponentOrder  order,
NXOpen.Assemblies.Component[]  componentsToReorder,
NXOpen.Assemblies.Component  targetComponent,
NXOpen.Assemblies.ComponentAssembly.OrderTargetLocation  beforeOrAfter 
)

Reorders the array of NXOpen.Assemblies.Component s before or after the target NXOpen.Assemblies.Component .

NXOpen.Assemblies.Component s to reorder and the target NXOpen.Assemblies.Component should be children of the same immediate parent.

Created in NX9.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
orderNXOpen.Assemblies.ComponentOrder in which components are reordered
componentsToReorderArray of components to be reordered
targetComponentComponents are moved before or after this component
beforeOrAfterWhether to move components before or after the target component
unsafe void NXOpen.Assemblies.ComponentAssembly.ReplaceReferenceSet ( NXOpen.Assemblies.Component  component,
string  newReferenceSet 
)

Replaces the reference set used by a component.

Note that the names of the default reference sets Empty and Entire Part can be obtained from NXOpen.Assemblies.Component.EmptyPartRefsetName or NXOpen.Assemblies.Component.EntirePartRefsetName .

Created in NX3.0.0

License requirements: None.

Parameters
componentThe component to edit. Must be directly owned by this assembly.
newReferenceSetThe name of the new reference set
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.ReplaceReferenceSetInOwners ( string  newReferenceSet,
NXOpen.Assemblies.Component[]  components 
)

Sets the reference set used to represent each component in an array.

This is the equivalent of calling:

<see cref="NXOpen.Assemblies.Component.DirectOwner"> NXOpen.Assemblies.Component.DirectOwner </see>
<see cref="NXOpen.Assemblies.ComponentAssembly.ReplaceReferenceSet"> NXOpen.Assemblies.ComponentAssembly.ReplaceReferenceSet </see>

on each component in the array. However, this method will ensure that the reference set operations are carried out in the correct order, so that any effects caused by a parent's reference set change will be correctly reflected in the children. If changing reference set on components at various levels in the assembly, use this method.

Note that the names of the default reference sets Empty and Entire Part can be obtained from NXOpen.Assemblies.Component.EmptyPartRefsetName or NXOpen.Assemblies.Component.EntirePartRefsetName .

Created in NX3.0.0

License requirements: None.

Parameters
newReferenceSetThe name of the new reference set
componentsComponents to be edited. Each component will have its reference set updated in its owning assembly.
Returns
list of errors encountered during the edit
unsafe void NXOpen.Assemblies.ComponentAssembly.RestructureComponents ( NXOpen.Assemblies.Component[]  origComponents,
NXOpen.Assemblies.Component  newParentComponent,
bool  deleteFlag,
out NXOpen.Assemblies.Component[]  newComponents,
out NXOpen.ErrorList  errorList 
)

Given an array of components and a specified parent this function will transfer the given components to the parent.

The original components do not need to be under the same parent assembly as each other.

The number of new components may be different from the original number of components if problems occurred during the transfer

Created in NX6.0.1

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
origComponentsArray of components to be restructured
newParentComponentDestination for restructure
deleteFlagFlag to delete original components
newComponentsRestructured components
errorListAny errors that occurred during the restructure
unsafe void NXOpen.Assemblies.ComponentAssembly.SetAsRequiredQuantity ( NXOpen.Assemblies.Component  component)

Sets the as-required quantity on this component.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to edit. Must be directly owned by this assembly.
unsafe void NXOpen.Assemblies.ComponentAssembly.SetDefault ( NXOpen.Assemblies.Arrangement  arrangement)

Set the default NXOpen.Assemblies.Arrangement for the given NXOpen.Assemblies.ComponentAssembly .

Created in NX7.5.2

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
arrangementThe new default NXOpen.Assemblies.Arrangement .
unsafe void NXOpen.Assemblies.ComponentAssembly.SetEmptyRefset ( NXOpen.Assemblies.Component  component)

Convenience method for setting the reference set used to represent a component to be empty

Created in NX3.0.0

License requirements: None.

Parameters
componentThe component to edit. Must be directly owned by this assembly.
unsafe void NXOpen.Assemblies.ComponentAssembly.SetEntirePartRefset ( NXOpen.Assemblies.Component  component)

Convenience method for setting the reference set used to represent a component to be the entire part.

Created in NX3.0.0

License requirements: None.

Parameters
componentThe component to edit. Must be directly owned by this assembly.
unsafe void NXOpen.Assemblies.ComponentAssembly.SetIntegerQuantity ( NXOpen.Assemblies.Component  component,
int  integerQuantity 
)

Sets the integer quantity on this component.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to edit. Must be directly owned by this assembly.
integerQuantityInteger quantity value
unsafe void NXOpen.Assemblies.ComponentAssembly.SetNonGeometricState ( NXOpen.Assemblies.Component  component,
bool  nonGeometricState 
)

Sets the component state to Geometric or Non-Geometric.

Component which are made non-geometric are undrawn from graphics area.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to edit. Must be directly owned by this assembly.
nonGeometricStateTrue to make component non-geometric, false otherwise
unsafe void NXOpen.Assemblies.ComponentAssembly.SetRealQuantity ( NXOpen.Assemblies.Component  component,
double  realQuantity,
string  quantityUnits 
)

Sets the real quantity and corresponding units on this component.

Created in NX6.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe component to edit. Must be directly owned by this assembly.
realQuantityReal quantity value
quantityUnitsUnits
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.ShowComponentsInIsolateView ( NXOpen.Assemblies.Component[]  components,
out NXOpen.View  view 
)

Shows array of components in Isolate view NXOpen.View .

If Isolate view doesn't exist then this API doesn't do anything. Returns NXOpen.View which is treated as Isolate View.

Created in NX11.0.1

License requirements: gateway ("UG GATEWAY")

Parameters
componentsArray of components to be shown in isolate view
viewReturn the isolate view
Returns
list of errors encountered during components shown in isolate view
unsafe NXOpen.Assemblies.Component NXOpen.Assemblies.ComponentAssembly.SubstituteComponent ( NXOpen.Assemblies.Component  component,
NXOpen.BasePart  part,
string  newName,
string  referenceSet,
int  layer,
NXOpen.Assemblies.ComponentAssembly.SubstitutionMode  mode 
)

Substitutes an old component with a new component.

The new component represents a new part, but will be placed in the same location as the original.

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentThe old component to be substituted.
partThe new part
newNameThe name for the new component
referenceSetThe name of the reference set for the new component
layerThe layer for the new component -1 means use the original layers defined in the component. 0 means use the work layer 1-256 means use the specified layer.
modeDefines the substitution mode
Returns
The new Component that replaces the old one.
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.SuppressComponents ( NXOpen.Assemblies.Component[]  components,
NXOpen.Assemblies.Arrangement[]  arrangements 
)

Suppresses an array of components

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentsNXOpen.Assemblies.Component s to be suppressed
arrangementsArrangements in which components should be suppressed. These arrangements must be defined in this ComponentAssembly
Returns
list of errors encountered during the suppress
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.SuppressComponents ( NXOpen.Assemblies.Component[]  components)

Suppresses an array of components in all NXOpen.Assemblies.Arrangement s in this ComponentAssembly

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentsNXOpen.Assemblies.Component s to be suppressed
Returns
list of errors encountered during the suppress
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.SuppressComponents ( NXOpen.Assemblies.Component[]  components,
NXOpen.Assemblies.Arrangement[]  arrangements,
string  expression 
)

Suppresses an array of components in all NXOpen.Assemblies.Arrangement s in this ComponentAssembly

Created in NX5.0.1

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentsNXOpen.Assemblies.Component s to be suppressed
arrangementsArrangements in which components should be unsuppressed
expressionSuppress components if expression evalutes zero else unsuppress components
Returns
list of errors encountered during the suppress
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.UnsuppressComponents ( NXOpen.Assemblies.Component[]  components,
NXOpen.Assemblies.Arrangement[]  arrangements 
)

Unsuppresses an array of components in this ComponentAssembly

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentsNXOpen.Assemblies.Component s to be unsuppressed
arrangementsArrangements in which components should be unsuppressed. These arrangements must be defined in this ComponentAssembly
Returns
list of errors encountered during the unsuppress
unsafe NXOpen.ErrorList NXOpen.Assemblies.ComponentAssembly.UnsuppressComponents ( NXOpen.Assemblies.Component[]  components)

Unsuppresses an array of components in all NXOpen.Assemblies.Arrangement s in this ComponentAssembly

Created in NX3.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

Parameters
componentsNXOpen.Assemblies.Component s to be unsuppressed
Returns
list of errors encountered during the unsuppress

Property Documentation

unsafe NXOpen.Assemblies.Arrangement NXOpen.Assemblies.ComponentAssembly.ActiveArrangement
getset

Returns or sets the currently active NXOpen.Assemblies.Arrangement for this ComponentAssembly

Created in NX3.0.0

License requirements to get this property: assemblies ("ASSEMBLIES MODULE")

License requirements to set this property: assemblies ("ASSEMBLIES MODULE")

NXOpen.Assemblies.ArrangementCollection NXOpen.Assemblies.ComponentAssembly.Arrangements
get

The collection of NXOpen.Assemblies.Arrangement s defined in the ComponentAssembly

Created in NX3.0.0

NXOpen.Assemblies.ClearanceSetCollection NXOpen.Assemblies.ComponentAssembly.ClearanceSets
get

The collection of NXOpen.Assemblies.ClearanceSet s defined in the ComponentAssembly

Created in NX9.0.0

NXOpen.Assemblies.ComponentPatternCollection NXOpen.Assemblies.ComponentAssembly.ComponentPatterns
get

The collection of NXOpen.Assemblies.ComponentPattern defined in the ComponentAssembly

Created in NX9.0.0

NXOpen.Assemblies.DrawingExplosionCollection NXOpen.Assemblies.ComponentAssembly.DrawingExplosions
get

The collection of NXOpen.Assemblies.DrawingExplosion s defined in the ComponentAssembly

Created in NX12.0.0

NXOpen.Assemblies.ExplosionCollection NXOpen.Assemblies.ComponentAssembly.Explosions
get

The collection of NXOpen.Assemblies.Explosion s defined in the ComponentAssembly

Created in NX3.0.0

NXOpen.Assemblies.OrderCollection NXOpen.Assemblies.ComponentAssembly.OrdersSet
get

The collection of NXOpen.Assemblies.Order s defined in the ComponentAssembly

Created in NX9.0.0

unsafe NXOpen.Positioning.ComponentPositioner NXOpen.Assemblies.ComponentAssembly.Positioner
get

Returns the component positioner for this assembly.

The positioner manages the component constraints.

Created in NX4.0.0

License requirements: assemblies ("ASSEMBLIES MODULE")

unsafe NXOpen.Assemblies.Component NXOpen.Assemblies.ComponentAssembly.RootComponent
get

Returns the top-level component, i.e.

the component at the root of the component tree.

This component corresponds to the part that owns this NXOpen.Assemblies.ComponentAssembly . The components below this will correspond to parts added by calling NXOpen.Assemblies.ComponentAssembly.AddComponent .

Note that this will be a null reference (Nothing in Visual Basic) if there are no components in the tree. (I.e. if the part that owns this ComponentAssembly is a piece part.)

Created in NX3.0.0

License requirements: None.

NXOpen.Assemblies.SubsetCollection NXOpen.Assemblies.ComponentAssembly.Subsets
get

The collection of NXOpen.Assemblies.Subset s defined in the ComponentAssembly

Created in NX8.5.0


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.